import * as THREE from './libs/three.js-r132/build/three.module.js';
import {loadGLTF, loadAudio, loadVideo} from "./libs/loader.js";
import {createChromaMaterial} from './libs/chroma-video.js';

document.addEventListener('DOMContentLoaded',onDOMContentLoaded);

function onDOMContentLoaded(){
    console.log("onDOMContentLoaded()->check 1");
    initialize();
}
async function initialize(){
console.log("initialize()->check 1");
const arButton = document.querySelector("#tombolar");
let currentSession =null;


//mengecek apakah browser dan sistemnya support AR WebXR
const supported = navigator.xr && navigator.xr.isSessionSupported("immersive-ar");
    
if(!supported){
    console.log("initialize()->check 2 UNSUPPORTED");
    arButton.textContext = "tidak support";
    arButton.disabled = true;
    console.log("initialize()->check 1.5 unsupported");
    return;
};

//const sceneXR   = new THREE.Scene();  
//const cameraXR  = new THREE.PerspectiveCamera();
//let rendererXR  = new THREE.WebGLRenderer({alpha:true});

//////////Scene untuk WebXR///////////////////
const sceneWebXR    = new THREE.Scene(); 
const cameraWebXR   = new THREE.PerspectiveCamera();
const rendererWebXR = new THREE.WebGLRenderer({alpha:true});
///////////Scene WebXR Done/////////////

///// set renderer displaying /////////////
rendererWebXR.setSize(window.innerWidth, window.innerHeight);
rendererWebXR.setPixelRatio(window.devicePixelRatio);
document.body.appendChild(rendererWebXR.domElement);



/// insert model from file
const model3d = await loadGLTF("./testar.glb"); 
sceneWebXR.add(model3d.scene);
//membuat lighting
const light = new THREE.HemisphereLight(0xffffff, 0xbbbbff,1);
sceneWebXR.add(light);

arButton.addEventListener("click", onARButtonClicked);
function onARButtonClicked(){
    if(currentSession){
        endProgram();
    }else{
        startWebXR();
    }
}



async function startWebXR(){
    console.log("initialize()StartWebXR()->check 1");
    

     

     ////////////script memanggil sesi webXR /////////////////////////
     //ketika session ar semua DOM Element hilang, supaya bisa overlay DOM Eelement AR Button caranya adalah
     //meminta fitur tambahan yaitu parameter optionalFeature tersebut 'dom-overlay'
     currentSession = await navigator.xr.requestSession('immersive-ar', {optionalFeatures: ['dom-overlay'], domOverlay: {root: document.body}});
     rendererWebXR.xr.enabled = true;
     rendererWebXR.xr.setReferenceSpaceType('local');//location of we start XR session  is the center of virtual space
     await rendererWebXR.xr.setSession(currentSession);

    
     ////////////script memanggil sesi webXR DONE/////////////////////////

     rendererWebXR.setAnimationLoop(animationLoopActionXR);
          
          function animationLoopActionXR(){
                rendererWebXR.render(sceneWebXR,cameraWebXR);
             // console.log("cameraXR x: ", xrcamera.position.x + ", y: " + xrcamera.position.y);
          }
}//menutup startwebxr

async function endProgram(){
    currentSession.end();
    rendererWebXR.clear();
    rendererWebXR.setAnimationLoop(null);
    arButton.style.display = "none";
}

}//menutup initalize
